<?php
/**
 * Created by PhpStorm.
 * User: jderosa
 * Date: 21/03/19
 * Time: 14.45
 */

namespace FiloBlu\RuleDayFromBirthday\Observer;

use FiloBlu\RuleDayFromBirthday\Model\Rule\Condition\Customer\Birthday;
use FiloBlu\RuleDayFromBirthday\Model\Rule\Condition\Customer\FirstOrder;
use FiloBlu\RuleDayFromBirthday\Model\Rule\Condition\Quote\SubtotalWithDiscountNoShipping;
use Magento\Framework\Event\Observer;
use Magento\Framework\Event\ObserverInterface;

/**
 * @class DayFromBirthdayConditionObserver
 * @package FiloBlu\RuleDayFromBirthday\Observer
 */
class DayFromBirthdayConditionObserver implements ObserverInterface
{

    /**
     * Execute observer.
     * @param Observer $observer
     * @return void
     */
    public function execute(Observer $observer)
    {
        $additional = $observer->getAdditional();
        $conditions = (array)$additional->getConditions();

        // Merging the old condition with our condition.
        $conditions = array_merge_recursive($conditions, [
            [
                'value' => [
                    [
                        'value' => Birthday::class,
                        'label' => __('Customer Birthday')
                    ]
                ], 'label' => __('Birthday Coupon')
            ],
            [
                'value' => [
                    [
                        'value' => FirstOrder::class,
                        'label' => __('X Days From Customer First Order')
                    ]
                ], 'label' => __('First Order Coupon')
            ],
            [
                'value' => [
                    [
                        'value' => SubtotalWithDiscountNoShipping::class,
                        'label' => __('New Subtotal with discounts no shipping (Incl. Tax)')
                    ]
                ], 'label' => __('FiloBlu Quote')
            ]
        ]);

        $additional->setConditions($conditions);
    }
}

